/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
//******************************************************************************
#include <msp430.h>
#include "driverlib.h"
#include "Defines.h"
#include "Board.h"
#include "MCx8323_System.h"
#include "NVM.h"



void NVM_Write()
{


    MCC_RW = WRITE;
    NVMWrite = 1;

    SLAVE_ID =  NVMSLAVEID;

    EUSCI_B_I2C_setSlaveAddress(EUSCI_I2C_BASE,
                SLAVE_ID
            );
    EndOfWrite = 0;
    EUSCI_B_I2C_setMode(EUSCI_I2C_BASE,
                        EUSCI_B_I2C_TRANSMIT_MODE
                  );

    while (EUSCI_B_I2C_SENDING_STOP == EUSCI_B_I2C_masterIsStopSent(EUSCI_I2C_BASE));

     EUSCI_B_I2C_masterSendStart(EUSCI_I2C_BASE);

     while (EndOfWrite == 0);


     int i_nvm;

           for (i_nvm = 0 ; i_nvm <64;i_nvm++)
           {
               NVMData[i_nvm]=0;
           }


}


void NVM_Read()
{

    SLAVE_ID =  NVMSLAVEID;
    MCC_RW = WRITE;
    NVMWrite = 0;
    MEMADDR_PROG=11;

    //send initial bytes
    EndOfWrite = 0;

    int wait;
    for(wait=0;wait<0xFFFF;wait++);

    EUSCI_B_I2C_setSlaveAddress(EUSCI_I2C_BASE,
                   SLAVE_ID
               );

    EUSCI_B_I2C_setMode(EUSCI_I2C_BASE,
                         EUSCI_B_I2C_TRANSMIT_MODE
                   );
    EUSCI_B_I2C_masterSendStart(EUSCI_I2C_BASE);

    while (EndOfWrite == 0);
    MEMADDR_PROG=11;
    MCC_RW = READ;

    EUSCI_B_I2C_setSlaveAddress(EUSCI_I2C_BASE,
                   SLAVE_ID
               );

       EUSCI_B_I2C_setMode(EUSCI_I2C_BASE,
                           EUSCI_B_I2C_RECEIVE_MODE
                     );
       RXCOUNT_I2C = 0;
       EUSCI_B_I2C_masterSendStart(EUSCI_I2C_BASE);



}
