/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

/*******************************************************************************
 *
 *  Serial_Cmd_Monitor.h - c file for serial command monitor for GUI
 *
 ******************************************************************************/
#ifndef SERIAL_CMD_MONITOR_H_
#define SERIAL_CMD_MONITOR_H_

#ifdef __MSP430FR2355AEP_BRD__
#define EUSCI_BASE EUSCI_A1_BASE
#define USCI_VECTOR USCI_A1_VECTOR

#define EUSCI_I2C_BASE EUSCI_B1_BASE
#define USCI_I2C_VECTOR USCI_B1_VECTOR

#define GPIO_PORT GPIO_PORT_P2
#define GPIO_PIN GPIO_PIN2
#endif

#ifdef __MSP430FR2355_LAUNCHPAD__
#define EUSCI_BASE EUSCI_A0_BASE
#define USCI_VECTOR USCI_A0_VECTOR

#define EUSCI_I2C_BASE EUSCI_B0_BASE
#define USCI_I2C_VECTOR USCI_B0_VECTOR

#define GPIO_PORT GPIO_PORT_P1
#define GPIO_PIN GPIO_PIN0
#endif


void ClearBufferRelatedParam();
void receivedDataCommand(unsigned char d);
extern int  MCC_RW ;
extern int mccDecode;

void MCC_Decode();

//RW CMD TYPE
#define READ 1
#define WRITE 0


#define     TEMP_THRESHOLD      4
#define     RW_CMD           0x80
#define     EXTENSION_BYTE      0x07



//ENDIANNESS
#define BIG_ENDIAN 1
#define LITTLE_ENDIAN 0
//ADDRESSIBLE SIZE
#define ADDRESSIBLE_32_BIT 1
#define ADDRESSIBLE_16_BIT 0
// override these depends on target: CMD_BUFFER_SIZE =  5 + sizeOfMauIn8BitByte * 63
#define CMD_BUFFER_SIZE 68 //1 + 4 + 63 = 68
unsigned char gInCmdBuffer[CMD_BUFFER_SIZE];
unsigned short gInCmdBufferIdx = 0;
int MEMADDR_PROG;
int cmd_received;
int MCC_RW, CRC_EN = 0;

volatile unsigned short gInCmdSkipCount;


char SLAVE_ID;

void ClearBufferRelatedParam();

#endif
